import java.util.*;

/** two ways of traversal Collection
 *  we only use BookListIsAL implementation of List<Book> 
 *  (we need List for sorting and remove(Book b) method, and
 *  the standard class LinkedList<Book> provides everything)
 *  @author abx
 */

public class Library2 {
	
    public static void main(String[] args) {
	
		List<Book> books = new BookListIsAL();
		//BookListWithLL books = new BookListWithLL();

		books.add(new Book("Java Software Solutions", false));
		books.add(new Book("Core Java Vol 1", false));
		books.add(new Book("Thinking in Java", false));
		books.add(new Book("A Hitchhiker's Guide to the Galaxy", true));
		books.add(new Book("À la recherche du temps perdu", false));

		// since books is a List object, to insert an element one has to use add(index,elem)
		books.add(2,new Book("Where's Spot?", true));
		books.add(0, new Book("Sein und Zeit", false));
		books.add(books.size()-1, new Book("The Very Hungry Caterpillar", true));
	
		System.out.println();
		System.out.print("Library book list:");
		System.out.println(" (" + books.size() + " books)\n");

		System.out.println(books.toString());
		
		System.out.println("Finding out which books are boring:");
		for (Iterator<Book> iter = books.iterator(); iter.hasNext(); ) {
			Book nextBook = iter.next();
			if (!nextBook.isFiction()) 
        	System.out.println(nextBook.toString() + " is boring.");
		}
		
		System.out.println("\nRemoving all books which are boring...");

		// for (Iterator<Book> iter = books.iterator(); iter.hasNext(); ) {
		// 					Book nextBook = iter.next();
		// 					if (!nextBook.isFiction()) 
		// 		        		iter.remove();
		// 				}
		 

		// Dangerous traversal by for-each loop with modification
		// Use this and you will get ConcurrentModificationException at runtime
		
		for (Book book: books) {
			if (book.isFiction()) books.remove(book);
		}
		
		
		System.out.println("\nThe list without boring books:");
		System.out.println(books.toString());
    }
}

